#pragma once

namespace Contacts {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	/// <summary>
	///   Form1
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(void)
		{
			InitializeComponent();
			//
			//TODO:   
			//
			//       
			dbPath = Environment::GetFolderPath 
				(Environment::SpecialFolder::MyDocuments); 
			//    
			oleDbConnection1->ConnectionString = 
				"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + 
				dbPath + "\\Contacts\\contacts.mdb"; 
			//  Images     
			imFolder = dbPath + "\\Contacts\\Images\\"; 
			//        
			toolStripStatusLabel1->Text = dbPath + "\\Contacts\\contacts.mdb"; 
			//   textBox1-textBox4    
			textBox1->DataBindings->Add((gcnew 
				Binding(L"Text", dataSet1, L"contacts.name", true))); 
			textBox2->DataBindings->Add((gcnew 
				Binding(L"Text", dataSet1, L"contacts.phone", true))); 
			textBox3->DataBindings->Add((gcnew 
				Binding(L"Text", dataSet1, L"contacts.email", true))); 
			textBox4->DataBindings->Add((gcnew 
				Binding(L"Text", dataSet1, L"contacts.img", true))); 
			//   
			oleDbDataAdapter1->Fill(dataTable1); 
		}

	protected:
		/// <summary>
		///    .
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}
	private: System::Data::OleDb::OleDbConnection^  oleDbConnection1;
	protected: 
	private: System::Data::OleDb::OleDbCommand^  oleDbSelectCommand1;

	private: System::Data::OleDb::OleDbCommand^  oleDbUpdateCommand1;
	private: System::Data::OleDb::OleDbCommand^  oleDbDeleteCommand1;
	private: System::Data::OleDb::OleDbDataAdapter^  oleDbDataAdapter1;
	private: System::Windows::Forms::DataGridView^  dataGridView1;





	private: System::Data::DataSet^  dataSet1;
	private: System::Data::DataTable^  dataTable1;
	private: System::Data::DataColumn^  dataColumn1;
	private: System::Data::DataColumn^  dataColumn2;
	private: System::Data::DataColumn^  dataColumn3;
	private: System::Data::DataColumn^  dataColumn4;
	private: System::Data::DataColumn^  dataColumn5;
	private: System::Windows::Forms::TextBox^  textBox1;
	private: System::Windows::Forms::DataGridViewTextBoxColumn^  cidDataGridViewTextBoxColumn;
	private: System::Windows::Forms::DataGridViewTextBoxColumn^  nameDataGridViewTextBoxColumn;
	private: System::Windows::Forms::DataGridViewTextBoxColumn^  phoneDataGridViewTextBoxColumn;
	private: System::Windows::Forms::DataGridViewTextBoxColumn^  emailDataGridViewTextBoxColumn;
	private: System::Windows::Forms::DataGridViewTextBoxColumn^  img;
	private: System::Windows::Forms::TextBox^  textBox2;
	private: System::Windows::Forms::TextBox^  textBox3;
	private: System::Windows::Forms::Label^  label1;
	private: System::Windows::Forms::Label^  label2;
	private: System::Windows::Forms::Label^  label3;
	private: System::Windows::Forms::TextBox^  textBox4;
	private: System::Windows::Forms::PictureBox^  pictureBox1;
	private: System::Windows::Forms::ToolTip^  toolTip1;
	private: System::Windows::Forms::OpenFileDialog^  openFileDialog1;
	private: System::Windows::Forms::StatusStrip^  statusStrip1;
	private: System::Windows::Forms::ToolStripStatusLabel^  toolStripStatusLabel1;
	private: System::Data::OleDb::OleDbCommand^  oleDbInsertCommand;
	private: System::ComponentModel::IContainer^  components;


	private:
		/// <summary>
		///   .
		/// </summary>


#pragma region Windows Form Designer generated code
		/// <summary>
		///      -  
		///       .
		/// </summary>
		void InitializeComponent(void)
		{
			this->components = (gcnew System::ComponentModel::Container());
			System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(Form1::typeid));
			this->oleDbConnection1 = (gcnew System::Data::OleDb::OleDbConnection());
			this->oleDbSelectCommand1 = (gcnew System::Data::OleDb::OleDbCommand());
			this->oleDbUpdateCommand1 = (gcnew System::Data::OleDb::OleDbCommand());
			this->oleDbDeleteCommand1 = (gcnew System::Data::OleDb::OleDbCommand());
			this->oleDbDataAdapter1 = (gcnew System::Data::OleDb::OleDbDataAdapter());
			this->oleDbInsertCommand = (gcnew System::Data::OleDb::OleDbCommand());
			this->dataGridView1 = (gcnew System::Windows::Forms::DataGridView());
			this->cidDataGridViewTextBoxColumn = (gcnew System::Windows::Forms::DataGridViewTextBoxColumn());
			this->nameDataGridViewTextBoxColumn = (gcnew System::Windows::Forms::DataGridViewTextBoxColumn());
			this->phoneDataGridViewTextBoxColumn = (gcnew System::Windows::Forms::DataGridViewTextBoxColumn());
			this->emailDataGridViewTextBoxColumn = (gcnew System::Windows::Forms::DataGridViewTextBoxColumn());
			this->img = (gcnew System::Windows::Forms::DataGridViewTextBoxColumn());
			this->dataSet1 = (gcnew System::Data::DataSet());
			this->dataTable1 = (gcnew System::Data::DataTable());
			this->dataColumn1 = (gcnew System::Data::DataColumn());
			this->dataColumn2 = (gcnew System::Data::DataColumn());
			this->dataColumn3 = (gcnew System::Data::DataColumn());
			this->dataColumn4 = (gcnew System::Data::DataColumn());
			this->dataColumn5 = (gcnew System::Data::DataColumn());
			this->textBox1 = (gcnew System::Windows::Forms::TextBox());
			this->textBox2 = (gcnew System::Windows::Forms::TextBox());
			this->textBox3 = (gcnew System::Windows::Forms::TextBox());
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->label2 = (gcnew System::Windows::Forms::Label());
			this->label3 = (gcnew System::Windows::Forms::Label());
			this->textBox4 = (gcnew System::Windows::Forms::TextBox());
			this->pictureBox1 = (gcnew System::Windows::Forms::PictureBox());
			this->toolTip1 = (gcnew System::Windows::Forms::ToolTip(this->components));
			this->openFileDialog1 = (gcnew System::Windows::Forms::OpenFileDialog());
			this->statusStrip1 = (gcnew System::Windows::Forms::StatusStrip());
			this->toolStripStatusLabel1 = (gcnew System::Windows::Forms::ToolStripStatusLabel());
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->dataGridView1))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->dataSet1))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->dataTable1))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->pictureBox1))->BeginInit();
			this->statusStrip1->SuspendLayout();
			this->SuspendLayout();
			// 
			// oleDbConnection1
			// 
			this->oleDbConnection1->ConnectionString = L"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\\Users\\Arkady\\Documents\\Contacts\\c" 
				L"ontacts.mdb";
			// 
			// oleDbSelectCommand1
			// 
			this->oleDbSelectCommand1->CommandText = L"SELECT        name, phone, email, img, cid\r\nFROM            contacts\r\nWHERE      " 
				L"  (name LIKE \?)";
			this->oleDbSelectCommand1->Connection = this->oleDbConnection1;
			this->oleDbSelectCommand1->Parameters->AddRange(gcnew cli::array< System::Data::OleDb::OleDbParameter^  >(1) {(gcnew System::Data::OleDb::OleDbParameter(L"name", 
				System::Data::OleDb::OleDbType::WChar, 50, System::Data::ParameterDirection::Input, false, static_cast<System::Byte>(0), 
				static_cast<System::Byte>(0), L"name", System::Data::DataRowVersion::Current, L"%%"))});
			// 
			// oleDbUpdateCommand1
			// 
			this->oleDbUpdateCommand1->CommandText = resources->GetString(L"oleDbUpdateCommand1.CommandText");
			this->oleDbUpdateCommand1->Connection = this->oleDbConnection1;
			this->oleDbUpdateCommand1->Parameters->AddRange(gcnew cli::array< System::Data::OleDb::OleDbParameter^  >(13) {(gcnew System::Data::OleDb::OleDbParameter(L"name", 
				System::Data::OleDb::OleDbType::VarWChar, 0, L"name")), (gcnew System::Data::OleDb::OleDbParameter(L"phone", System::Data::OleDb::OleDbType::VarWChar, 
				0, L"phone")), (gcnew System::Data::OleDb::OleDbParameter(L"email", System::Data::OleDb::OleDbType::VarWChar, 0, L"email")), 
				(gcnew System::Data::OleDb::OleDbParameter(L"img", System::Data::OleDb::OleDbType::VarWChar, 0, L"img")), (gcnew System::Data::OleDb::OleDbParameter(L"IsNull_name", 
				System::Data::OleDb::OleDbType::Integer, 0, System::Data::ParameterDirection::Input, static_cast<System::Byte>(0), static_cast<System::Byte>(0), 
				L"name", System::Data::DataRowVersion::Original, true, nullptr)), (gcnew System::Data::OleDb::OleDbParameter(L"Original_name", 
				System::Data::OleDb::OleDbType::VarWChar, 0, System::Data::ParameterDirection::Input, false, static_cast<System::Byte>(0), 
				static_cast<System::Byte>(0), L"name", System::Data::DataRowVersion::Original, nullptr)), (gcnew System::Data::OleDb::OleDbParameter(L"IsNull_phone", 
				System::Data::OleDb::OleDbType::Integer, 0, System::Data::ParameterDirection::Input, static_cast<System::Byte>(0), static_cast<System::Byte>(0), 
				L"phone", System::Data::DataRowVersion::Original, true, nullptr)), (gcnew System::Data::OleDb::OleDbParameter(L"Original_phone", 
				System::Data::OleDb::OleDbType::VarWChar, 0, System::Data::ParameterDirection::Input, false, static_cast<System::Byte>(0), 
				static_cast<System::Byte>(0), L"phone", System::Data::DataRowVersion::Original, nullptr)), (gcnew System::Data::OleDb::OleDbParameter(L"IsNull_email", 
				System::Data::OleDb::OleDbType::Integer, 0, System::Data::ParameterDirection::Input, static_cast<System::Byte>(0), static_cast<System::Byte>(0), 
				L"email", System::Data::DataRowVersion::Original, true, nullptr)), (gcnew System::Data::OleDb::OleDbParameter(L"Original_email", 
				System::Data::OleDb::OleDbType::VarWChar, 0, System::Data::ParameterDirection::Input, false, static_cast<System::Byte>(0), 
				static_cast<System::Byte>(0), L"email", System::Data::DataRowVersion::Original, nullptr)), (gcnew System::Data::OleDb::OleDbParameter(L"IsNull_img", 
				System::Data::OleDb::OleDbType::Integer, 0, System::Data::ParameterDirection::Input, static_cast<System::Byte>(0), static_cast<System::Byte>(0), 
				L"img", System::Data::DataRowVersion::Original, true, nullptr)), (gcnew System::Data::OleDb::OleDbParameter(L"Original_img", 
				System::Data::OleDb::OleDbType::VarWChar, 0, System::Data::ParameterDirection::Input, false, static_cast<System::Byte>(0), 
				static_cast<System::Byte>(0), L"img", System::Data::DataRowVersion::Original, nullptr)), (gcnew System::Data::OleDb::OleDbParameter(L"Original_cid", 
				System::Data::OleDb::OleDbType::Integer, 0, System::Data::ParameterDirection::Input, false, static_cast<System::Byte>(0), 
				static_cast<System::Byte>(0), L"cid", System::Data::DataRowVersion::Original, nullptr))});
			// 
			// oleDbDeleteCommand1
			// 
			this->oleDbDeleteCommand1->CommandText = resources->GetString(L"oleDbDeleteCommand1.CommandText");
			this->oleDbDeleteCommand1->Connection = this->oleDbConnection1;
			this->oleDbDeleteCommand1->Parameters->AddRange(gcnew cli::array< System::Data::OleDb::OleDbParameter^  >(9) {(gcnew System::Data::OleDb::OleDbParameter(L"IsNull_name", 
				System::Data::OleDb::OleDbType::Integer, 0, System::Data::ParameterDirection::Input, static_cast<System::Byte>(0), static_cast<System::Byte>(0), 
				L"name", System::Data::DataRowVersion::Original, true, nullptr)), (gcnew System::Data::OleDb::OleDbParameter(L"Original_name", 
				System::Data::OleDb::OleDbType::VarWChar, 0, System::Data::ParameterDirection::Input, false, static_cast<System::Byte>(0), 
				static_cast<System::Byte>(0), L"name", System::Data::DataRowVersion::Original, nullptr)), (gcnew System::Data::OleDb::OleDbParameter(L"IsNull_phone", 
				System::Data::OleDb::OleDbType::Integer, 0, System::Data::ParameterDirection::Input, static_cast<System::Byte>(0), static_cast<System::Byte>(0), 
				L"phone", System::Data::DataRowVersion::Original, true, nullptr)), (gcnew System::Data::OleDb::OleDbParameter(L"Original_phone", 
				System::Data::OleDb::OleDbType::VarWChar, 0, System::Data::ParameterDirection::Input, false, static_cast<System::Byte>(0), 
				static_cast<System::Byte>(0), L"phone", System::Data::DataRowVersion::Original, nullptr)), (gcnew System::Data::OleDb::OleDbParameter(L"IsNull_email", 
				System::Data::OleDb::OleDbType::Integer, 0, System::Data::ParameterDirection::Input, static_cast<System::Byte>(0), static_cast<System::Byte>(0), 
				L"email", System::Data::DataRowVersion::Original, true, nullptr)), (gcnew System::Data::OleDb::OleDbParameter(L"Original_email", 
				System::Data::OleDb::OleDbType::VarWChar, 0, System::Data::ParameterDirection::Input, false, static_cast<System::Byte>(0), 
				static_cast<System::Byte>(0), L"email", System::Data::DataRowVersion::Original, nullptr)), (gcnew System::Data::OleDb::OleDbParameter(L"IsNull_img", 
				System::Data::OleDb::OleDbType::Integer, 0, System::Data::ParameterDirection::Input, static_cast<System::Byte>(0), static_cast<System::Byte>(0), 
				L"img", System::Data::DataRowVersion::Original, true, nullptr)), (gcnew System::Data::OleDb::OleDbParameter(L"Original_img", 
				System::Data::OleDb::OleDbType::VarWChar, 0, System::Data::ParameterDirection::Input, false, static_cast<System::Byte>(0), 
				static_cast<System::Byte>(0), L"img", System::Data::DataRowVersion::Original, nullptr)), (gcnew System::Data::OleDb::OleDbParameter(L"Original_cid", 
				System::Data::OleDb::OleDbType::Integer, 0, System::Data::ParameterDirection::Input, false, static_cast<System::Byte>(0), 
				static_cast<System::Byte>(0), L"cid", System::Data::DataRowVersion::Original, nullptr))});
			// 
			// oleDbDataAdapter1
			// 
			this->oleDbDataAdapter1->DeleteCommand = this->oleDbDeleteCommand1;
			this->oleDbDataAdapter1->InsertCommand = this->oleDbInsertCommand;
			this->oleDbDataAdapter1->SelectCommand = this->oleDbSelectCommand1;
			cli::array< System::Data::Common::DataColumnMapping^ >^ __mcTemp__1 = gcnew cli::array< System::Data::Common::DataColumnMapping^  >(5) {(gcnew System::Data::Common::DataColumnMapping(L"name", 
				L"name")), (gcnew System::Data::Common::DataColumnMapping(L"phone", L"phone")), (gcnew System::Data::Common::DataColumnMapping(L"email", 
				L"email")), (gcnew System::Data::Common::DataColumnMapping(L"img", L"img")), (gcnew System::Data::Common::DataColumnMapping(L"cid", 
				L"cid"))};
			this->oleDbDataAdapter1->TableMappings->AddRange(gcnew cli::array< System::Data::Common::DataTableMapping^  >(1) {(gcnew System::Data::Common::DataTableMapping(L"Table", 
				L"contacts", __mcTemp__1))});
			this->oleDbDataAdapter1->UpdateCommand = this->oleDbUpdateCommand1;
			// 
			// oleDbInsertCommand
			// 
			this->oleDbInsertCommand->CommandText = L"INSERT INTO `contacts` (`name`, `phone`, `email`, `img`) VALUES (\?, \?, \?, \?)";
			this->oleDbInsertCommand->Connection = this->oleDbConnection1;
			this->oleDbInsertCommand->Parameters->AddRange(gcnew cli::array< System::Data::OleDb::OleDbParameter^  >(4) {(gcnew System::Data::OleDb::OleDbParameter(L"name", 
				System::Data::OleDb::OleDbType::VarWChar, 0, L"name")), (gcnew System::Data::OleDb::OleDbParameter(L"phone", System::Data::OleDb::OleDbType::VarWChar, 
				0, L"phone")), (gcnew System::Data::OleDb::OleDbParameter(L"email", System::Data::OleDb::OleDbType::VarWChar, 0, L"email")), 
				(gcnew System::Data::OleDb::OleDbParameter(L"img", System::Data::OleDb::OleDbType::VarWChar, 0, L"img"))});
			// 
			// dataGridView1
			// 
			this->dataGridView1->AllowUserToResizeColumns = false;
			this->dataGridView1->AutoGenerateColumns = false;
			this->dataGridView1->ColumnHeadersHeightSizeMode = System::Windows::Forms::DataGridViewColumnHeadersHeightSizeMode::AutoSize;
			this->dataGridView1->Columns->AddRange(gcnew cli::array< System::Windows::Forms::DataGridViewColumn^  >(5) {this->cidDataGridViewTextBoxColumn, 
				this->nameDataGridViewTextBoxColumn, this->phoneDataGridViewTextBoxColumn, this->emailDataGridViewTextBoxColumn, this->img});
			this->dataGridView1->DataMember = L"contacts";
			this->dataGridView1->DataSource = this->dataSet1;
			this->dataGridView1->Location = System::Drawing::Point(12, 132);
			this->dataGridView1->Name = L"dataGridView1";
			this->dataGridView1->RowHeadersWidth = 24;
			this->dataGridView1->ScrollBars = System::Windows::Forms::ScrollBars::Vertical;
			this->dataGridView1->Size = System::Drawing::Size(459, 78);
			this->dataGridView1->TabIndex = 0;
			this->dataGridView1->UserDeletingRow += gcnew System::Windows::Forms::DataGridViewRowCancelEventHandler(this, &Form1::dataGridView1_UserDeletingRow);
			// 
			// cidDataGridViewTextBoxColumn
			// 
			this->cidDataGridViewTextBoxColumn->DataPropertyName = L"cid";
			this->cidDataGridViewTextBoxColumn->HeaderText = L"cid";
			this->cidDataGridViewTextBoxColumn->Name = L"cidDataGridViewTextBoxColumn";
			this->cidDataGridViewTextBoxColumn->Visible = false;
			// 
			// nameDataGridViewTextBoxColumn
			// 
			this->nameDataGridViewTextBoxColumn->DataPropertyName = L"name";
			this->nameDataGridViewTextBoxColumn->HeaderText = L"";
			this->nameDataGridViewTextBoxColumn->Name = L"nameDataGridViewTextBoxColumn";
			// 
			// phoneDataGridViewTextBoxColumn
			// 
			this->phoneDataGridViewTextBoxColumn->DataPropertyName = L"phone";
			this->phoneDataGridViewTextBoxColumn->HeaderText = L"";
			this->phoneDataGridViewTextBoxColumn->Name = L"phoneDataGridViewTextBoxColumn";
			// 
			// emailDataGridViewTextBoxColumn
			// 
			this->emailDataGridViewTextBoxColumn->DataPropertyName = L"email";
			this->emailDataGridViewTextBoxColumn->HeaderText = L".";
			this->emailDataGridViewTextBoxColumn->Name = L"emailDataGridViewTextBoxColumn";
			// 
			// img
			// 
			this->img->DataPropertyName = L"img";
			this->img->HeaderText = L"img";
			this->img->Name = L"img";
			this->img->Visible = false;
			this->img->Width = 94;
			// 
			// dataSet1
			// 
			this->dataSet1->DataSetName = L"NewDataSet";
			this->dataSet1->Tables->AddRange(gcnew cli::array< System::Data::DataTable^  >(1) {this->dataTable1});
			// 
			// dataTable1
			// 
			this->dataTable1->Columns->AddRange(gcnew cli::array< System::Data::DataColumn^  >(5) {this->dataColumn1, this->dataColumn2, 
				this->dataColumn3, this->dataColumn4, this->dataColumn5});
			this->dataTable1->TableName = L"contacts";
			// 
			// dataColumn1
			// 
			this->dataColumn1->AutoIncrement = true;
			this->dataColumn1->ColumnName = L"cid";
			this->dataColumn1->DataType = System::Int32::typeid;
			// 
			// dataColumn2
			// 
			this->dataColumn2->ColumnName = L"name";
			// 
			// dataColumn3
			// 
			this->dataColumn3->ColumnName = L"phone";
			// 
			// dataColumn4
			// 
			this->dataColumn4->ColumnName = L"email";
			// 
			// dataColumn5
			// 
			this->dataColumn5->ColumnName = L"img";
			// 
			// textBox1
			// 
			this->textBox1->Location = System::Drawing::Point(97, 12);
			this->textBox1->Name = L"textBox1";
			this->textBox1->Size = System::Drawing::Size(123, 20);
			this->textBox1->TabIndex = 1;
			// 
			// textBox2
			// 
			this->textBox2->Location = System::Drawing::Point(97, 38);
			this->textBox2->Name = L"textBox2";
			this->textBox2->Size = System::Drawing::Size(123, 20);
			this->textBox2->TabIndex = 2;
			// 
			// textBox3
			// 
			this->textBox3->Location = System::Drawing::Point(97, 64);
			this->textBox3->Name = L"textBox3";
			this->textBox3->Size = System::Drawing::Size(123, 20);
			this->textBox3->TabIndex = 3;
			// 
			// label1
			// 
			this->label1->AutoSize = true;
			this->label1->Location = System::Drawing::Point(59, 15);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(32, 13);
			this->label1->TabIndex = 4;
			this->label1->Text = L":";
			// 
			// label2
			// 
			this->label2->AutoSize = true;
			this->label2->Location = System::Drawing::Point(36, 41);
			this->label2->Name = L"label2";
			this->label2->Size = System::Drawing::Size(55, 13);
			this->label2->TabIndex = 5;
			this->label2->Text = L":";
			// 
			// label3
			// 
			this->label3->AutoSize = true;
			this->label3->Location = System::Drawing::Point(37, 67);
			this->label3->Name = L"label3";
			this->label3->Size = System::Drawing::Size(54, 13);
			this->label3->TabIndex = 6;
			this->label3->Text = L".:";
			// 
			// textBox4
			// 
			this->textBox4->Location = System::Drawing::Point(337, 38);
			this->textBox4->Name = L"textBox4";
			this->textBox4->Size = System::Drawing::Size(100, 20);
			this->textBox4->TabIndex = 7;
			this->textBox4->TextChanged += gcnew System::EventHandler(this, &Form1::textBox4_TextChanged);
			// 
			// pictureBox1
			// 
			this->pictureBox1->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->pictureBox1->Location = System::Drawing::Point(327, 7);
			this->pictureBox1->Name = L"pictureBox1";
			this->pictureBox1->Size = System::Drawing::Size(134, 106);
			this->pictureBox1->SizeMode = System::Windows::Forms::PictureBoxSizeMode::StretchImage;
			this->pictureBox1->TabIndex = 8;
			this->pictureBox1->TabStop = false;
			this->pictureBox1->Click += gcnew System::EventHandler(this, &Form1::pictureBox1_Click);
			// 
			// openFileDialog1
			// 
			this->openFileDialog1->FileName = L"openFileDialog1";
			// 
			// statusStrip1
			// 
			this->statusStrip1->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(1) {this->toolStripStatusLabel1});
			this->statusStrip1->Location = System::Drawing::Point(0, 229);
			this->statusStrip1->Name = L"statusStrip1";
			this->statusStrip1->Size = System::Drawing::Size(483, 22);
			this->statusStrip1->TabIndex = 9;
			this->statusStrip1->Text = L"statusStrip1";
			// 
			// toolStripStatusLabel1
			// 
			this->toolStripStatusLabel1->Name = L"toolStripStatusLabel1";
			this->toolStripStatusLabel1->Size = System::Drawing::Size(118, 17);
			this->toolStripStatusLabel1->Text = L"toolStripStatusLabel1";
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(483, 251);
			this->Controls->Add(this->statusStrip1);
			this->Controls->Add(this->pictureBox1);
			this->Controls->Add(this->textBox4);
			this->Controls->Add(this->label3);
			this->Controls->Add(this->label2);
			this->Controls->Add(this->label1);
			this->Controls->Add(this->textBox3);
			this->Controls->Add(this->textBox2);
			this->Controls->Add(this->textBox1);
			this->Controls->Add(this->dataGridView1);
			this->Name = L"Form1";
			this->Text = L"-3";
			this->FormClosing += gcnew System::Windows::Forms::FormClosingEventHandler(this, &Form1::Form1_FormClosing);
			this->Load += gcnew System::EventHandler(this, &Form1::Form1_Load);
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->dataGridView1))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->dataSet1))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->dataTable1))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->pictureBox1))->EndInit();
			this->statusStrip1->ResumeLayout(false);
			this->statusStrip1->PerformLayout();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion
		private: 
			String^ dbPath; //   
			String^ imFolder; //   

//    
private: System::Void Form1_Load(System::Object^  sender, System::EventArgs^  e) {
			 //     SELECT  , 
			 //     , 
			 //     : 
			 // oleDbDataAdapter1->SelectCommand->Parameters[0]->Value = "%%"; 
			 //        SELECT 
			 oleDbDataAdapter1->Fill(dataTable1); 
	 }
//       Delete
private: System::Void dataGridView1_UserDeletingRow(System::Object^  sender, 
			 System::Windows::Forms::DataGridViewRowCancelEventArgs^  e) {
             System::Windows::Forms::DialogResult dr = 
				 MessageBox::Show(" ?", 
				 " ", 
				 MessageBoxButtons::OKCancel, 
				 MessageBoxIcon::Warning, 
				 MessageBoxDefaultButton::Button2); 
			 if (dr == System::Windows::Forms::DialogResult::Yes) 
			 {
				 e->Cancel = true; 
			 }
	 }
//    
private: System::Void Form1_FormClosing(System::Object^  sender, 
			 System::Windows::Forms::FormClosingEventArgs^  e) {
			//   
            oleDbDataAdapter1->Update(dataSet1->Tables["contacts"]);
	 }
//    textBox4 - 
//  ,        
private: System::Void textBox4_TextChanged(System::Object^  sender, System::EventArgs^  e) {
			 String^ imageFile; 
			 String^ msg; //    

			 if (textBox4->Text == String::Empty) 
			 {
				 imageFile = imFolder + "nobody.jpg"; 
			 }
			 else 
				 imageFile = imFolder + textBox4->Text;
			 //   
			 try 
			 {
				 msg = ""; 
				 pictureBox1->Image = System::Drawing::Bitmap::FromFile(imageFile); 
			 }
			 catch (System::IO::FileNotFoundException^ e) 
			 {
				 //       
				 //  pictureBox1 
				 msg = "File nof found: " + imageFile; 
				 pictureBox1->Image = nullptr; 
				 pictureBox1->Refresh(); 
			 }
		 }
//    pictureBox1 
private: System::Void pictureBox1_Click(System::Object^  sender, System::EventArgs^  e) {
			 openFileDialog1->Title = " "; 
			 openFileDialog1->InitialDirectory = imFolder; 
			 openFileDialog1->Filter = "|*.jpg| |*.*"; 
			 openFileDialog1->FileName = ""; 
			 if (openFileDialog1->ShowDialog() == 
				 System::Windows::Forms::DialogResult::OK) 
			 {
				 //     
				 // ,       imFolder 
				 bool r = openFileDialog1->FileName->ToLower()->Contains( 
					 openFileDialog1->InitialDirectory->ToLower()); 
				 if (r == true) 
				 {
					 //   , . .   , 
					 //    imFolder 
					 textBox4->Text = openFileDialog1->SafeFileName; 
				 }
				 else 
				 {
					 //      Images. 
					 //   -   
					 //    ,   , 
					 //   
					 try 
					 {
						 //   
						 System::IO::File::Copy(openFileDialog1->FileName, 
							 imFolder + openFileDialog1->SafeFileName);
						 textBox4->Text = openFileDialog1->SafeFileName; 
					 }
					 catch (System::Exception^ e) 
					 {
						 System::Windows::Forms::DialogResult dr; 
						 dr = MessageBox::Show(e->Message + 
							 "  ?", "", 
							 MessageBoxButtons::OKCancel, 
							 MessageBoxIcon::Warning, 
							 MessageBoxDefaultButton::Button2); 
						 if (dr == System::Windows::Forms::DialogResult::OK) 
						 {
							 //   
							 System::IO::File::Copy(openFileDialog1->FileName, 
								 imFolder + openFileDialog1->SafeFileName, 
								 true); 
							 textBox4->Text = openFileDialog1->SafeFileName; 
						 }
					 }
				 }
			 }
	 }
};
}

